{
 "cells": [
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "# Course 11\n",
    "\n",
    "## Objective\n",
    "- OO overview\n",
    "\n",
    "### Problem\n",
    "One of yours friend is opening a depo where he attends to store different boxes with items. The depo contains different type of shelves. The owner would like the for start the following facilities:\n",
    "- easy way to describe its depo\n",
    "- a option to suggest how to arrange the boxes, so they use less space\n",
    "- a option to easy find a product type in the depo\n",
    "\n",
    "\n",
    "### Possible Solution\n",
    "Define a class *Box* that has the following attributes a producer, height, width, length and weight. "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 126,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Box details: producer=upc, width=1, height=2, lenght=3 and weight=4\n"
     ]
    }
   ],
   "source": [
    "class Box(object):\n",
    "    def __init__(self, producer, height, width, length, weight):\n",
    "        self.producer = producer\n",
    "        self.height = height\n",
    "        self.width = width\n",
    "        self.length = length\n",
    "        self.weight = weight\n",
    "        self.shelf = None\n",
    "   \n",
    "    @property\n",
    "    def height(self):\n",
    "        return self.__height\n",
    "    \n",
    "    @height.setter\n",
    "    def height(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The height of a box cannot be negative\")\n",
    "        self.__height = val\n",
    "        \n",
    "    @property\n",
    "    def width(self):\n",
    "        return self.__width\n",
    "    \n",
    "    @width.setter\n",
    "    def width(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The width of a box cannot be negative\")\n",
    "        self.__width = val\n",
    "        \n",
    "    @property\n",
    "    def length(self):\n",
    "        return self.__length\n",
    "    \n",
    "    @length.setter\n",
    "    def length(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The length of a box cannot be negative\")\n",
    "        self.__length = val\n",
    "        \n",
    "    @property\n",
    "    def weight(self):\n",
    "        return self.__weight\n",
    "    \n",
    "    @weight.setter\n",
    "    def weight(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The weight of a box cannot be negative\")\n",
    "        self.__weight = val\n",
    "    \n",
    "    def __repr__(self):\n",
    "        return \"Box details: producer={}, width={}, height={}, lenght={} and weight={}\"\\\n",
    "        .format(self.producer, self.height, self.width, self.length, self.weight)\n",
    "        \n",
    "b = Box(\"upc\", 1,2,3,4)\n",
    "\n",
    "print(b)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Create a class *Shelf* that as an ID, a length, a maximum weight it can support. "
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 130,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "Shelf details: id=s1, length=10, weight=2, height=3, width=4\n"
     ]
    }
   ],
   "source": [
    "class Shelf(object):\n",
    "    def __init__(self, id, length, weight, height, width):\n",
    "        self.id = id\n",
    "        self.length = length\n",
    "        self.weight = weight\n",
    "        self.height = height\n",
    "        self.width = width\n",
    "        self.boxes =[]\n",
    "        self.free_length = self.length\n",
    "        \n",
    "    @property\n",
    "    def weight(self):\n",
    "        return self.__weight\n",
    "    \n",
    "    @weight.setter\n",
    "    def weight(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The weight of a shelf cannot be negative\")\n",
    "        self.__weight = val\n",
    "    @property\n",
    "    def length(self):\n",
    "        return self.__length\n",
    "    \n",
    "    @length.setter\n",
    "    def length(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The length of a shelf cannot be negative\")\n",
    "        self.__length = val\n",
    "    @property\n",
    "    def height(self):\n",
    "        return self.__height\n",
    "    \n",
    "    @height.setter\n",
    "    def height(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The height of a shelf cannot be negative\")\n",
    "        self.__height = val\n",
    "        \n",
    "    @property\n",
    "    def width(self):\n",
    "        return self.__width\n",
    "    \n",
    "    @width.setter\n",
    "    def width(self, val):\n",
    "        if val <= 0:\n",
    "            raise ValueError(\"The width of a shelf cannot be negative\")\n",
    "        self.__width = val\n",
    "    def __repr__(self):\n",
    "        return \"Shelf details: id={}, length={}, weight={}, height={}, width={}\"\\\n",
    "    .format(self.id, self.length, self.weight, self.height, self.width)\n",
    "s1 = Shelf(\"s1\", 10, 2,3,4)\n",
    "s2 = Shelf(\"s2\", 5, 2,5,6)\n",
    "s3 = Shelf(\"s3\", 6, 4,7,8)\n",
    "print(s1)"
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "A depo contains a list of shelfs and a list of boxes. Create a class depo that allows the possibility to add/remove shelfs/boxes and has a method that propose the depo owner a possible assignment of the boxes in such way it uses less shelfs (we suppose that the boxex height is less that shelves space and the wight is not an restriction)."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 132,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "box.length 3  current_self.free_length 10\n",
      "nr of shelves: 1\n",
      "Depo shelves=[Shelf details: id=s1, length=10, weight=2, height=3, width=4, Shelf details: id=s3, length=6, weight=4, height=7, width=8, Shelf details: id=s2, length=5, weight=2, height=5, width=6] boxes=[Box details: producer=upc, width=1, height=2, lenght=3 and weight=4]\n"
     ]
    }
   ],
   "source": [
    "class Depo(object):\n",
    "    def __init__(self):\n",
    "        self.boxes = []\n",
    "        self.shelves =[]\n",
    "    def add_box(self, box):\n",
    "        if not isinstance(box, Box):\n",
    "            raise TypeError(\"A object of type Box is expected\")\n",
    "        self.boxes.append(box)\n",
    "    def add_shelf(self, shelf):\n",
    "        if not isinstance(shelf, Shelf):\n",
    "            raise TypeError(\"A object of type Shelf is expected\")\n",
    "        self.shelves.append(shelf)\n",
    "    def __repr__(self):\n",
    "        return \"Depo shelves={} boxes={}\".format(self.shelves, self.boxes)\n",
    "    def __aux_add_box_to_shelf(self, current_shelf, box):\n",
    "        current_shelf.free_length -= box.length\n",
    "        current_shelf.boxes.append(box)\n",
    "        box.shelf = current_shelf\n",
    "    def repartition(self):\n",
    "        #sort the list of shelfs\n",
    "        self.shelves.sort(key=lambda x: x.length, reverse=True)\n",
    "        #sort the list of boxea\n",
    "        self.boxes.sort(key=lambda x: x.length, reverse=True)\n",
    "        #reset free space\n",
    "        for shelf in self.shelves:\n",
    "            shelf.free_length = shelf.length\n",
    "        current_shelf_index = 0\n",
    "        current_shelf = self.shelves[current_shelf_index]\n",
    "        for box in self.boxes:\n",
    "                print(\"box.length\", box.length, \" current_self.free_length\", current_shelf.free_length)\n",
    "                if current_shelf.free_length >= box.length:\n",
    "                    self.__aux_add_box_to_shelf(current_shelf, box)\n",
    "                else:\n",
    "                    current_shelf_index += 1\n",
    "                    if current_shelf_index == len(self.shelves):\n",
    "                        raise ValueError(\"Too few shelves. It is not enough room\")\n",
    "                    current_shelf = self.shelves[current_shelf_index]\n",
    "                    self.__aux_add_box_to_shelf(current_shelf, box)\n",
    "        return current_shelf_index + 1\n",
    "\n",
    "        \n",
    "d = Depo()\n",
    "d.add_box(b)\n",
    "d.add_shelf(s1)\n",
    "d.add_shelf(s2)\n",
    "d.add_shelf(s3)\n",
    "print(\"nr of shelves:\", d.repartition())\n",
    "print(d) "
   ]
  },
  {
   "cell_type": "markdown",
   "metadata": {},
   "source": [
    "Extend from the class Box the classes ChocolateBox and PuzzleBox. Chocolate box has like attributes the ingredients and Puzzle box has like attributes the number of puzzle pieces. Count how many chocolate boxes are in the depo and display on which shelfs are placed."
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 133,
   "metadata": {},
   "outputs": [
    {
     "name": "stdout",
     "output_type": "stream",
     "text": [
      "box.length 9  current_self.free_length 10\n",
      "box.length 3  current_self.free_length 1\n",
      "box.length 3  current_self.free_length 3\n",
      "Number of shelves: 2\n",
      "{'s1': [Chocolate box producer=kandia, ingredients=sugar], 's3': [Chocolate box producer=milka, ingredients=milk]}\n"
     ]
    }
   ],
   "source": [
    "class ChocolateBox(Box):\n",
    "    def __init__(self,  producer, height, width, length, weight, ingredients):\n",
    "        Box.__init__(self, producer, height, width, length, weight)\n",
    "        self.ingredients = ingredients\n",
    "    def __repr__(self):\n",
    "        return \"Chocolate box producer={}, ingredients={}\".format(self.producer, self.ingredients)\n",
    "    \n",
    "class PuzzleBox(Box):\n",
    "    def __init__(self,  producer, height, width, length, weight, no_pieces):\n",
    "        Box.__init__(self, producer, height, width, length, weight)\n",
    "        self.no_pieces = no_pieces\n",
    "    def __repr__(self):\n",
    "        return \"Puzzle box producer={}, number of pices={}\".format(self.producer, self.no_pieces)\n",
    "    \n",
    "c1 = ChocolateBox(\"milka\",  1,2,3,4, \"milk\")\n",
    "c2 = ChocolateBox(\"kandia\", 1,2,9,4, \"sugar\") \n",
    "d.add_box(c1)\n",
    "d.add_box(c2)\n",
    "print(\"Number of shelves:\", d.repartition())\n",
    "dd = {}\n",
    "for item in d.boxes:\n",
    "    if isinstance(item, ChocolateBox):\n",
    "        if item.shelf.id in dd:\n",
    "            dd[item.shelf.id].append(item)\n",
    "        else:\n",
    "            dd[item.shelf.id] = [item]\n",
    "print(dd)"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {
    "collapsed": true
   },
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "Python 3",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.6.3"
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
